<template>
  <div class="participant-questionnaire">
    <ob-tabs>
      <ob-tabs-pane
        class="participant-questionnaire__pane"
        title="Анкета"
      >
        <div
          v-for="(group, idx) in questionGroups"
          :key="group.uuid"
          class="group"
        >
          <div
            :class="[
              'group__header',
              { last: idx === questionGroups.length - 1 },
              { opened: !group.opened }
            ]"
            @click="questionGroups[idx].opened = !questionGroups[idx].opened"
          >
            <i
              :class="{ opened: !group.opened }"
              class="icon chevron-down group__header-icon"
            />

            <span>{{ group.title }}</span>
          </div>

          <div
            :class="{ closed: group.opened }"
            class="group__content"
          >
            <div
              v-for="question in group.questions"
              :key="question.uuid"
              class="question"
            >
              <div class="question__title">
                {{ question.title }}
              </div>
              <div
                v-for="(answer, idx) in question.answer"
                :key="`answer-${idx}`"
                class="answer"
              >
                <div
                  v-if="answer.title"
                  class="answer__title"
                >
                  {{ answer.title }}
                </div>

                {{ answer.value }}
              </div>
              <div
                v-if="question.comment"
                class="comment"
              >
                {{ question.comment }}
              </div>
            </div>
          </div>
        </div>
      </ob-tabs-pane>

      <ob-tabs-pane
        class="participant-questionnaire__pane"
        title="Прикрепленные файлы"
      >
        <div
          v-if="files.length"
          class="existing-files"
        >
          <div
            class="existing-file"
            v-for="file in files"
            :key="file.uuid"
            data-qa="download"
            @click="downloadFile(file)"
          >
            <span class="existing-file-text">
              {{ file.name }}
            </span>
          </div>
        </div>

        <template v-else>
          Прикреплённых файлов нет
        </template>
      </ob-tabs-pane>
    </ob-tabs>
  </div>
</template>

<script>
import api from '@/api'
import moment from 'moment'

import ObTabs     from 'common-components/src/obComponents/obTabs'
import ObTabsPane from 'common-components/src/obComponents/obTabs/ObTabsPane'

export default {
  components: {
    ObTabs,
    ObTabsPane,
  },

  props: {
    questionnaireUuid: {
      type: String,
      required: true
    },
    participantUuid: {
      type: String,
      required: true
    }
  },

  data () {
    return {
      sections: null,
      files: [],
      questionGroups: []
    }
  },

  methods: {
    getAnswer(question) {
      const fields = question.fields

      let answer = []

      if (question.type === 'SELECT') {
        answer = fields.find((field) => {
          return field.value === true
        })

        if (answer && answer.title) {
          answer = [{ value: answer.title }]
        }
      } else if (question.type === 'MULTISELECT') {
        answer = fields.filter((field) => {
          return field.value !== false
        }).map((field) => {
          return field.title
        }).join(', ')

        answer = [{ value: answer }]
      } else {
        if (fields.length === 1) {
          return [{ value: fields[0].value }]
        }

        answer = fields.map((field) => {
          let value = field.value

          if (field.type === 'TIME') {
            value = moment(value).utc().format('HH:mm')
          } else if (field.type === 'DATE') {
            value = moment(value).format('DD.MM.YYYY')
          }

          return {
            value,
            title: field.title,
            pos  : field.pos
          }
        }).sort((a, b) => {
          return a.pos - b.pos
        })
      }

      return answer
    },

    async downloadFile (file) {
      const res = await api.files.getFile(file.uuid)

      const fileName = res.name
      const url = window.URL.createObjectURL(new Blob([res.data]))
      const link = document.createElement('a')

      link.href = url
      link.setAttribute('download', fileName)

      document.body.appendChild(link)

      link.click()

      document.body.removeChild(link)
    }
  },

  async beforeMount () {
    const {
      files,
      questionGroups
    } = await api.tenders.getQuestionnaireByCarrier(this.questionnaireUuid, this.participantUuid)

    this.files = files
    this.questionGroups = questionGroups
      .sort((a, b) => a.pos - b.pos)
      .map(({ uuid, title, questions }) => ({
        uuid,
        title,
        questions,
        opened: false
      }
    ))

    this.questionGroups.forEach(group => {
      group.questions.forEach(question => {
        question.answer = this.getAnswer(question)
      })
    })
  }
}
</script>

<style lang="scss" scoped>
@import "~common-components/src/static/css/mixins";

.participant-questionnaire {
  &__pane {
    margin-top: 20px;
  }

  .group {
    &:not(:last-child) {
      margin-bottom: 30px;
    }

    &__header {
      @include font-mixin(14px, 18px, normal, $color-blue-navy-blue);

      display: flex;
      justify-content: flex-start;
      align-items: center;
      background-color: $blue-150;
      border-top: 1px solid $obQuestionnaire-section_toggler_border;
      padding: 3px 20px 0;
      height: 40px;
      cursor: pointer;
      position: relative;
      margin-bottom: 20px;

      &.last:not(.opened)::after {
        position: absolute;
        content: '';
        top: 100%;
        left: 0;
        width: 100%;
        border-bottom: 1px solid $obQuestionnaire-section_toggler_border;
      }
    }

    &__header-icon {
      font-size: 24px;
      margin: -2px 10px 0 0;

      &:not(.opened) {
        transform: rotate(-90deg);
      }
    }

    &__content {
      padding-left: 35px;

      &.closed {
        display: none;
      }
    }
  }

  .question {
    &:not(:last-child) {
      margin-bottom: 30px;
    }

    &__title {
      @include font-mixin(16px, 20px, 700, $color-text-base, 0.4px);

      margin-bottom: 10px;
    }
  }

  .answer {
    @include font-mixin(14px, 20px, 400, $color-text-base);

    &:not(:last-child) {
      margin-bottom: 10px;
    }

    &__title {
      width: 130px;
      color: $color-grey-span;
    }
  }

  .comment {
    @include font-mixin(14px, 20px, 400, $color-text-base);
  }

  .existing-files {
    display: flex;
    flex-direction: column;
    align-items: flex-start;
  }

  .existing-file {
    display: flex;
    padding: 5px 12px;
    border-radius: 19px;
    background: $lavender;
    min-height: 28px;
    cursor: pointer;

    &:not(:last-child) {
      margin-bottom: 10px;
    }
  }

  .existing-file-text {
    line-height: 18px;
    color: $color-blue-navy-blue;
  }
}
</style>